/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package GA;

import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author root
 */
public class Chromosome  implements Cloneable {
    int [] chromosome;
    int nCity;
    int fitness;
    int MAXFITNESS=150;

    //Creates an empty chromosome and initializes all genes to be 0.
    public Chromosome (int n){
        nCity = n;
        chromosome = new int [n];
        initZero();
        fitness = 0;
    }

    //Creates a chromosome with the given sequence of cities.
    public Chromosome (ArrayList <Integer> arr){
        //System.out.println ("arr.size() = "+ arr.size());
        nCity = arr.size();
        chromosome = new int [nCity];
        for (int i=0;i<arr.size();i++){
          //  System.out.print(arr.get(i)+ "  ");
            chromosome[i] = arr.get(i);
        }
        //System.out.println ();
        fitness = 0;
    }

    //Initializes all the genes of the chromosome to zero.
    public void initZero (){
        for (int i=0;i<nCity;i++)
            chromosome[i] = 0;
    }
    public Object Clone (){
         try{
            Chromosome c1 = (Chromosome) super.clone();
            c1.chromosome = (int[])chromosome.clone();
            c1.fitness = fitness;
            c1.nCity = nCity;
            return c1;
        }
        catch (Exception e){
            System.out.println ("Error in chromosome cloning!");
            return null;
        }
    }

    /**
     * Calculates the Fitness of the chromosome. The distance is not stored in the
     * chromosome itself. So it should be passed as a formal parameter.
     * The algo is assign fitness value of the chromosome as the total distance has to be
     * covered while going to the cities in the sequence given in the chromosome.
     *
     * As this is a minimization problem we substruct the fitness from a large value.
     * And maximize the substrated value. This will in turn minimize the actual value.
     */
    public int fitnessFunction (int [][] distance){
        int i=0,j=0,sum=0;
        for (;i<nCity;i++){
            sum+= distance [chromosome[i]][chromosome[(i+1)%nCity]];
        }
        //Assigns the fitness to the chromosome.
        this.fitness = MAXFITNESS - sum;
        return fitness;
    }

    /* this function randomly fills a chromosome. This is used when populating
     * the initial population.
     * This populates all valid states of the chromosome. i.e. no cities are generated
     * twice. So the state generated is legal.
     */
    public void randFill (int [][] distance){
        Random r = new Random();
        int index1,index2,temp;
        for (int i=0;i<nCity;i++){
            chromosome[i] = i;
        }

        //Swaps two randomly chosen index values of the chromosome.
        for (int i=0;i<nCity/4;i++){
            index1 = r.nextInt(nCity);
            index2 = r.nextInt(nCity);
            temp = chromosome[index1];
            chromosome[index1] = chromosome[index2];
            chromosome[index2]=temp;
        }
        this.fitnessFunction(distance);
    }

    public String getChromosome (){
        String str="";
        for (int i=0;i<nCity;i++)
            str+= chromosome[i]+ "  ";
        str+=" : "+this.fitness;
        return str;
    }

    public boolean ifEqual (Chromosome c){
        for (int i=0;i<nCity;i++)
            if (c.chromosome[i]!=this.chromosome[i])
                return false;
        return true;
    }

    public boolean ifValid (){
        int [] count = new int [nCity];

        //System.out.println ("Hello");
        for (int i=0;i<nCity;i++)
            count[i] = 0;
        for (int i=0;i<nCity;i++)
            if (count[this.chromosome[i]]==0)
                count[this.chromosome[i]]++;
            else{
         //       System.out.println ("invalid");
                return false;
            }
        //System.out.println ("valid");
        return true;
    }
}
