/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GA;

import GA.Chromosome;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author root
 */
public class Population {

    ArrayList<Chromosome> population = new ArrayList<Chromosome>();

    ;
    int nChr; // Number of chromosome in the population.
    int nCity; // No of genes in a chromosome. i.e. no of cities.
    int[][] distance;
    Random rii;

    /**
     * This constructor creates new populatin with randomly filled chromosome.
     * @param nPopulationLength This parameter you can set from the interface.
     * @param nCity Number of cities the traveller has to travel
     * @param mat the distance matrix for the problem.
     */
    public Population(int nPopulationLength, int nCity, int[][] mat) {
        nChr = nPopulationLength;
        this.nCity = nCity;
        distance = new int[nCity][nCity];
        rii = new Random(nChr);
        for (int i = 0; i < nCity; i++) {
            distance[i] = new int[nCity];
        }
        for (int i = 0; i < nCity; i++) {
            for (int j = 0; j < nCity; j++) {
                distance[i][j] = mat[i][j];
            }
        }
        Chromosome c = new Chromosome(nCity);

        for (int i = 0; i < nChr; i++) {
            c.randFill(distance);
            population.add(i, (Chromosome) c.Clone());
        }
    }

    public Chromosome[] Selection(int matingLength) {
        return rouletteWheel(matingLength);
    }

    public Chromosome[] rouletteWheel(int matingLength) {
        Chromosome[] c = new Chromosome[matingLength];
        double[] Px = new double[nChr];
        double rand = 0;

        int i, j = 0;
        double sum = 0;
        double sum1 = 0;
        for (i = 0; i < nChr; i++) {
            sum += this.population.get(i).fitness;
        }
        for (i = 0; i < nChr; i++) {
            Px[i] = this.population.get(i).fitness / sum;
            sum1+=Px[i];
            System.out.println("["+i+"] "+this.population.get(i).getChromosome() + " -> " + sum1);
        }
        i = 0;
        j = 0;
        sum = 0;
        while (i < matingLength) {
            //rand = rii.nextDouble();
            rand = Math.random();
            System.out.print(rand + " ");
            j=0;
            sum = Px[j % nChr];
            while (sum < rand) {
                sum = sum + Px[(j++) % nChr];
            }
            System.out.println("Selected - sum=" + sum + " index-> " + (j % nChr));
            c[i] = (Chromosome) population.get(j % nChr).Clone();
            i++;
        }
        System.out.println();
        return c;
    }

    public Chromosome[] rankbased(int matingLength) {
        Chromosome[] c = new Chromosome[nChr];
        //TODO implement rank based selection procedure.
        Chromosome[] selected = new Chromosome[matingLength];
        ArrayList<Chromosome> rank = new ArrayList<Chromosome>();

        int i, j = 0;
        for (i = 0; i < this.nChr; i++) {
            c[i] = (Chromosome) this.population.get(i).Clone();
        }

        //Sort c[] according to their fitness.
        Chromosome temp = null;
        for (i = 0; i < c.length - 1; i++) {
            for (j = i + 1; j < c.length; j++) {
                if (c[i].fitness > c[j].fitness) {
                    //... Exchange elements
                    temp = (Chromosome) c[i].Clone();
                    c[i] = (Chromosome) c[j].Clone();
                    c[j] = (Chromosome) temp.Clone();
                }
            }
        }

        //Rank the individual according to their fitness.
        for (i = 0; i < c.length - 1; i++) {
            if (!c[i].ifEqual(c[i + 1])) {
                rank.add(c[i]);
            }
        }
        //All the individual in the population is equal.
        if (rank.size() == 0) {
            rank.add(c[0]);
        }
        int dim = 0;
        for (int ll = 0; ll < rank.size(); ll++) {
            dim += ll;
        }

        double sum = 0;
        double[] P = new double[rank.size()];
        //Random r = new Random();
        double B = 100.0;

        for (i = 0; i < rank.size(); i++) {
            P[i] = (double) (i + 1) / (double) dim;
            //P[i]=1-Math.exp(i);
            //System.out.println (rank.get(i).getChromosome()+" "+P[i]);
        }

        //System.out.println ("Rqanking -");
        //for (j=0;j<rank.size();j++)
        //    System.out.println (rank.get(j).getChromosome()+" P[]= "+P[j]);
        //System.out.println ("The selected chromosomes are - ");
        i = 0;
        while (i < matingLength) {
            double rand = Math.random();
            //j=0;
            sum = P[j % rank.size()];
            while (sum < rand) {
                sum = sum + P[(j++) % rank.size()];
            }
            //if (((Chromosome) rank.get(j%rank.size())).ifValid()){
            selected[i] = (Chromosome) rank.get(j % rank.size()).Clone();
            //    System.out.println (selected[i].getChromosome());
            i++;
            //}
        }
        //  System.out.println ("-------------------------------");
        return selected;
    }

    public Chromosome[] selectNewPopulation_RW(ArrayList<Chromosome> p) {
        Chromosome[] c = new Chromosome[nChr];
        double[] Px = new double[p.size()];
        Random r = new Random();
        int i, j = 0;
        double sum = 0;
        for (i = 0; i < p.size(); i++) {
            sum += p.get(i).fitness;
        }
        for (i = 0; i < p.size(); i++) {
            Px[i] = p.get(i).fitness / sum;
        }
        i = 0;
        //j=0;
        while (i < nChr) {
            double rand = r.nextDouble();
            j = 0;
            sum = Px[j % p.size()];
            while (sum < rand) {
                sum = sum + Px[(j++) % p.size()];
            }
            //  if (p.get(j%p.size()).ifValid()){
            c[i] = (Chromosome) p.get(j % p.size()).Clone();
            i++;
            //}
        }
        return c;
    }

    public Chromosome[] selectNewPopulation_rand(ArrayList<Chromosome> p) {
        Chromosome[] c = new Chromosome[nChr];
        ArrayList arr = new ArrayList();
        int selectedindex;
        for (int i = 0; i < nChr; i++) {
            selectedindex = (int)(Math.random() * p.size());
            while (true){
                if (arr.indexOf(selectedindex)==-1){
                    c[i] = p.get(selectedindex);
                    arr.add(selectedindex);
                    break;
                }
                else
                    selectedindex = (int)(Math.random() * p.size());
            }
        }
        return c;
    }

    public Chromosome[] crossOver_single_point(Chromosome parent1, Chromosome parent2) {
        Chromosome[] child = new Chromosome[2];
        child[0] = new Chromosome(nCity);
        child[1] = new Chromosome(nCity);

       
        int index = (int)(Math.random() *(nCity - 1)); //Chooses the single point of changing.
        int i, j;
        System.out.println ("The single point = "+index);
        //Form the children.
        for (j = 0; j < index; j++) {
            child[0].chromosome[j] = parent1.chromosome[j];
            child[1].chromosome[j] = parent2.chromosome[j];
        }
        for (j = index; j < nCity; j++) {
            child[0].chromosome[j] = parent2.chromosome[j];
            child[1].chromosome[j] = parent1.chromosome[j];
        }
        child[0].fitnessFunction(distance);
        child[1].fitnessFunction(distance);
        return child;
    }

    public Chromosome[] crossOver(Chromosome parent1, Chromosome parent2) {
        //System.out.println ("Doing cross over!");
        int i, j;
        Chromosome[] child = new Chromosome[2];
        //TODO Perform cyclic cross over.
        ArrayList<Integer> c = new ArrayList();
        //ArrayList<Integer>p1 = parent1.getChromosomeArray();
        //ArrayList<Integer>p2 = parent2.getChromosomeArray();

        //Create child 1.
        for (i = 0; i < nCity; i++) {
            c.add(-1);
        }
        
        c.set(0, parent1.chromosome[0]);
        //int start = 1;
        if (Math.random() > 0.5) {
            c.set(0, parent2.chromosome[0]);
            //    start = 2;
        }

        for (i = 0; i < parent1.nCity; i++) {
            if (c.get(i) == -1 && !c.contains(parent2.chromosome[i])) {
                c.set(i, parent2.chromosome[i]);
            } else {
                c.set(i, parent1.chromosome[i]);
            }
        }

        /*  System.out.print ("child1 = ");
        for (int m=0;m<c.size();m++)
        System.out.print (c.get(m)+ "  ");
        System.out.println ();
         */
        child[0] = new Chromosome(c);
        child[0].fitnessFunction(distance);
        c.clear();
        for (i = 0; i < nCity; i++) {
            c.add(-1);
        }
        // Create the 2nd child!
        c.set(0, parent1.chromosome[0]);
        if (Math.random() > 0.5) {
            c.set(0, parent2.chromosome[0]);
        }
        for (i = 0; i < parent2.nCity; i++) {
            if (c.get(i) == -1 && !c.contains(parent1.chromosome[i])) {
                c.set(i, parent1.chromosome[i]);
            } else {
                c.set(i, parent2.chromosome[i]);
            }
        }
        /*
        System.out.print ("child2 = ");
        for (int m=0;m<c.size();m++)
        System.out.print (c.get(m)+ "  ");
        System.out.println ();
         */
        child[1] = new Chromosome(c);
        child[1].fitnessFunction(distance);
        //c.clear();
        return child;
    }

    /**
     * Selects two randomly selected location and swaps their values.
     * i.e. this changes the city position. The formal parameter passed to this method
     * changes inplace.
     * @param c The chromosome to be mutated.
     */
    public void mutation(Chromosome c) {
        //Random r = new Random();
        int index1 =(int)(Math.random()*(nCity));
        int index2 = (int)(Math.random()*(nCity));
        int temp = c.chromosome[index1];
        Chromosome c1 = (Chromosome) c.Clone();
        System.out.print (c.getChromosome()+" -> ");
        c.chromosome[index1] = c.chromosome[index2];
        c.chromosome[index2] = temp;
        c.fitnessFunction(distance);
        if (c.fitness < c1.fitness)
            c = (Chromosome) c1.Clone();
        System.out.println (c.getChromosome());
    }

    /**
     * This returns the chromosome in the population with the best i.e. maximum fitness.
     * @return
     */
    public Chromosome BestInd() {
        Chromosome best = population.get(0);
        for (int i = 1; i < nChr; i++) {
            if (population.get(i).fitness > best.fitness) {
                best = (Chromosome) population.get(i).Clone();
            }
        }
        return best;
    }

    public String getPopulation() {
        String str = "";
        for (int i = 0; i < population.size(); i++) {
            str += population.get(i).getChromosome() + "\n";
        }
        return str;
    }

    public void setPopulation(Chromosome[] c) {
        population.clear();
        for (int i = 0; i < c.length; i++) {
            population.add(c[i]);
        }
        this.BestInd();
    }

    public ArrayList<Chromosome> getPopulationArray() {
        return population;
    }
}
