/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SA;

import java.util.Random;

/**
 *
 * @author Abhirup
 */
public class State implements Cloneable{
    int [][]state;
    int noOfCity;
    int energy;
    int [][]distance;
    public State(int n) {
        noOfCity = n;
        int i;
        state = new int[n][n];
        for (i = 0; i < n; i++) {
            state[i] = new int[n];
        }
        distance = new int[n][n];
        for (i = 0; i < n; i++) {
            distance[i] = new int[n];
        }
    }
    public State (int [][]mat, int n){
        int i,j;
        noOfCity = n;
        state = new int[n][n];
        for (i = 0; i < n; i++) {
            state[i] = new int[n];
        }
        distance = new int[n][n];
        for (i = 0; i < n; i++) {
            distance[i] = new int[n];
        }
        for (i=0;i<n;i++){
            for (j=0;j<n;j++){
                    distance[i][j] = mat[i][j];
            }
        }
        this.calculateEnergy();
    }
    public Object Clone (){
         try{
            State c1 = (State) super.clone();
            c1.state = (int[][])state.clone();
            c1.distance = (int[][])distance.clone();
            c1.energy = energy;
            c1.noOfCity = noOfCity;
            return c1;
        }
        catch (Exception e){
            System.out.println ("Error in chromosome cloning!");
            return null;
        }
    }
    public void InitState (){
        int i,j;
        for (i=0;i<noOfCity;i++)
            for (j=0;j<noOfCity;j++)
                if (i==j)
                    state[i][j] = 1;
        Random r = new Random();
        int limit = r.nextInt(10);
        i=0;
        while (i++<limit)
            rowSwap();
        energy = calculateEnergy();
    }
    public void rowSwap (){
        Random r = new Random();
        int a;
        int index = (int)(r.nextDouble()*(noOfCity-1));
        //System.out.println ("Swaping "+index+" and "+(index+1));
        for (int i=0;i<noOfCity;i++){
            a = state[index][i];
            state[index][i] = state[(index+1)%noOfCity][i];
            state[(index+1)%noOfCity][i] = a;
        }
        //energy = calculateEnergy();
    }
    public String display (){
        String s="";
        for (int i=0;i<noOfCity;i++){
            for (int j=0;j<noOfCity;j++)
                s+=state[i][j]+" ";
            s+="\n";
        }
        s=s+" Energy = "+energy+"\n";
        return s;
    }
    public int calculateEnergy (){
        int C1,C2,C3,i,j,k,sum;
        C1=0;
        for (i=0;i<noOfCity;i++){
            sum=0;
            for (k=0;k<noOfCity;k++)
                sum+=state[i][k];
            C1 += Math.pow((sum-1),2);
        }
      //  System.out.println ("C1 = "+C1);

        C2=0;
        for (i=0;i<noOfCity;i++){
            sum=0;
            for (k=0;k<noOfCity;k++)
                sum+=state[k][i];
            C2 +=  Math.pow((sum-1),2);
        }
      //  System.out.println ("C2 = "+C2);
        sum = 0;
        /*for (i=0;i<noOfCity;i++){
            for (j=0;j<noOfCity;j++){
                for (k=0;k<noOfCity;k++){
                    System.out.println (distance[i][j] +"*"+ state[i][k] +"*"+ state[i][(k+1)%noOfCity]+
                            distance[i][j] +"*"+ state[i][k] +"*"+ state[i][(k+1)%noOfCity]);
                    sum+=distance[i][j] * state[i][k] * state[i][(k+1)%noOfCity];
                }
            }
        }*/
        /*for (i=0;i<noOfCity;i++){
            for (j=0;j<noOfCity;j++)
                   System.out.print (distance [i][j]+" ");
            System.out.println ();
        }*/
        sum = 0;
        for (k=0;k<noOfCity;k++){
            for (i=0;i<noOfCity;i++){
                for (j=0;j<noOfCity;j++){
                   // System.out.print("distance("+i+","+j+") * state("+i+","+k+") * state("+j+","+(k+1)%noOfCity+") + ");
                    sum += (distance[i][j]*state[i][k]*state[j][(k+1)%noOfCity]);
           //         System.out.print ((distance[i][j]*state[i][k]*state[j][(k+1)%noOfCity])+"  ");
                }
            }
          //  System.out.println ();
        }
        
        C3 = sum;
        int s = C1+C2+C3;
        this.energy = s;
       // System.out.println ("----------------------");
       // System.out.println ("C3 = "+C3);
        return s;
    }
    public State child (){
        Random r = new Random();
        int a;
        State s = (State)this.Clone();
        int index = (int)(r.nextDouble()*(noOfCity-1));
        //System.out.println ("Swaping "+index+" and "+(index+1));
        for (int i=0;i<noOfCity;i++){
            a = s.state[i][index];
            s.state[i][index] = s.state[i][(index+1)%noOfCity];
            s.state[i][(index+1)%noOfCity] = a;
        }
        s.energy = s.calculateEnergy();
        return s;
    }
}
